;; -*- Mode: Lisp; Syntax: ANSI-Common-Lisp -*-

(in-package :common-lisp-user)

(eval-when (:compile-toplevel :load-toplevel :execute)
  (asdf:operate 'asdf:load-op :cffi)
  (asdf:operate 'asdf:load-op :asdf-additions))

(defpackage #:iolib-alien-grovel-system
  (:use :common-lisp :cffi :asdf-additions))

#+cffi-features:no-foreign-funcall
(error "IOLIB-ALIEN-GROVEL needs an implementation that has support for FOREIGN-FUNCALL.")

(in-package #:iolib-alien-grovel-system)

(with-foreign-object (a :uchar 4)
  (dotimes (i 4)
    (setf (mem-aref a :unsigned-char i) (1+ i)))
  (pushnew (case (mem-ref a :unsigned-int)
             (#x01020304 :big-endian)
             (#x04030201 :little-endian)
             (otherwise
              (error "Your machine seems to be neither little-endian nor big-endian. Please report this to the maintainer(s).")))
           *features*))

(asdf:defsystem :iolib-alien-grovel
  :author "Dan Knapp <dankna@accela.net> and Stelian Ionescu <stelian.ionescu-zeus@poste.it>"
  :maintainer "Stelian Ionescu <stelian.ionescu-zeus@poste.it>"
  :version "0.5.5"
  :default-component-class muffled-source-file
  :components ((:file "iolib-alien-grovel")))
